browser.ecodmsapi.log("Startup...");

browser.menus.create({
  id: "sendToDms",
  title: browser.i18n.getMessage("sendToDms"),
  visible: false,
  contexts: ["page","message_list"],
  async onclick(info) {

    browser.ecodmsapi.ecoDMS_doArchive();
  },
});

browser.browserAction.onClicked.addListener((tab) => 
{
    browser.browserAction.isEnabled({tabId: tab.id}).then(function(enabled) {
        if (enabled)
            browser.ecodmsapi.ecoDMS_doArchive();
    });
    
    
});

browser.composeAction.onClicked.addListener((tab,info) => 
{
     browser.composeAction.isEnabled({tabId: tab.id}).then(function(enabled) {
        if (enabled)
            browser.ecodmsapi.ecoDMS_doSendAndArchive();
    });
});

browser.tabs.onUpdated.addListener((tabId,changeInfo,tab) => 
{
    
    browser.mailTabs.getSelectedMessages(tabId).then(function (msgList) {
        
        let hasMessages = msgList.messages.length > 0;
        
        browser.menus.update("sendToDms", { visible: hasMessages });
        if (hasMessages)
            browser.browserAction.enable(tabId);
        else
            browser.browserAction.disable(tabId);
        
    });
    
    browser.ecodmsapi.ecoDMS_checkAttachmentContextMenus();
    
    
});


browser.composeScripts.register({js: [{file: "sendscript.js"}]});

async function scriptMessage(message) {
  
    browser.ecodmsapi.log("Got message: "+message.cmd);
    if (message.cmd == "register")
    {
        await browser.composeAction.disable();
        await browser.ecodmsapi.registerSendStateObserver();
    }
}

async function onCommand(cmd, state) {
    browser.ecodmsapi.log("onCommand: "+cmd+" / "+state);
    if (cmd === "sendButtonState")
    {
        if (state===true)
        {
            browser.composeAction.disable();
        }
        else
        {
            browser.composeAction.enable();
        }
    }
}

browser.ecodmsapi.onCommand.addListener(onCommand);
browser.runtime.onMessage.addListener(scriptMessage);

browser.ecodmsapi.log("Startup complete.");
